package org.apithefire.web.wicket;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.protocol.http.WebApplication;
import org.apithefire.util.Objects;

public abstract class WicketApplication extends WebApplication {
	
	public static WicketApplication create(
			final Class<? extends WebPage> homePage) {
		return create(homePage, Stage.DEPLOYMENT);
	}
	
	public static WicketApplication create(
			final Class<? extends WebPage> homePage, final Stage stage) {
		Objects.nonNull(homePage);
		Objects.nonNull(stage);
		return new WicketApplication() {
			@Override
			public Class<? extends WebPage> getHomePage() {
				return homePage;
			}

			@Override
			public Stage getStage() {
				return stage;
			}
		};
	}

	@Override
	public abstract Class<? extends WebPage> getHomePage();
	
	public abstract Stage getStage();
	
	@Override
	public final String getConfigurationType() {
		return getStage().name();
	}
	
}
