package org.apithefire.web.wicket;

import org.apache.wicket.protocol.http.IWebApplicationFactory;
import org.apache.wicket.protocol.http.WebApplication;
import org.apache.wicket.protocol.http.WicketFilter;
import org.apithefire.util.Objects;

public abstract class WicketServlet extends
		org.apache.wicket.protocol.http.WicketServlet {
	
	private abstract class AppWicketFilter extends WicketFilter {

		public abstract WebApplication getWebApplication();
		
		@Override
		protected IWebApplicationFactory getApplicationFactory() {
			return new IWebApplicationFactory() {
				public WebApplication createApplication(
						org.apache.wicket.protocol.http.WicketFilter filter) {
					return getWebApplication();
				}
			};
		}
		
	}
	
	public static WicketServlet create(final WicketApplication app) {
		Objects.nonNull(app);
		return new WicketServlet() {
			@Override
			public WicketApplication getApplication() {
				return app;
			}
		};
	}
	
	public abstract WicketApplication getApplication();
	
	@Override
	protected WicketFilter newWicketFilter() {
		return new AppWicketFilter() {
			@Override
			public WebApplication getWebApplication() {
				return getApplication();
			}
		};
	}

}
